| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Protected Attributes | Private Member Functions | List of all members
HepRndm::Engine< TYPE > Class Template Reference

`#include <src/RndmGenSvc/HepRndmEngine.h>`

Inheritance diagram for HepRndm::Engine< TYPE >:
[legend]
Collaboration diagram for HepRndm::Engine< TYPE >:
[legend]

## Public Member Functions
StatusCode | initialize () override
| Initialize the Engine. More...
StatusCode | finalize () override
| Finalize the Engine. More...
StatusCode | setSeeds (const std::vector< long > &seed) override
| Set seeds. More...
StatusCode | seeds (std::vector< long > &seed) const override
| Retrieve seeds. More...
| BaseEngine (const std::string &name, ISvcLocator *loc)
| Standard Constructor. More...
Public Member Functions inherited from HepRndm::BaseEngine
| BaseEngine (const std::string &name, ISvcLocator *loc)
CLHEP::HepRandomEngine * | hepEngine ()
const CLHEP::HepRandomEngine * | hepEngine () const
double | rndm () const override
StatusCode | finalize () override
Public Member Functions inherited from RndmEngine
StatusCode | initialize () override
| Service override: initialization. More...
double | rndm () const override
| Single shot returning single random number. More...
StatusCode | rndmArray (std::vector< double > &array, long howmany, long start=0) const override
| Multiple shots returning vector with flat random numbers. More...
StreamBuffer & | serialize (StreamBuffer &str) override
| Input serialization from stream buffer. More...
StreamBuffer & | serialize (StreamBuffer &str) const override
| Output serialization to stream buffer. More...
Public Member Functions inherited from extends< Service, IRndmEngine, ISerialize >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
| Declare used tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Public Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const
| Backward compatibility function for getting the output level. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...

## Protected Attributes
Gaudi::Property< std::vector< long > > | m_seeds {this, "Seeds", {}, "seed table"}
Gaudi::Property< int > | m_col {this, "Column", 0}
Gaudi::Property< int > | m_row {this, "Row", 1}
Gaudi::Property< int > | m_lux {this, "Luxury", 3}
Gaudi::Property< bool > | m_useTable {this, "UseTable", false}
Gaudi::Property< bool > | m_setSingleton {this, "SetSingleton", false}
Protected Attributes inherited from HepRndm::BaseEngine
std::unique_ptr< CLHEP::HepRandomEngine > | m_hepEngine
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, " unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Private Member Functions
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine () override
| Create new HepEngine.... More...
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()
template<>
std::unique_ptr< CLHEP::HepRandomEngine > | createEngine ()

## Additional Inherited Members
Public Types inherited from extends< Service, IRndmEngine, ISerialize >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
using | Factory = Gaudi::PluginService::Factory< IService *(const std::string &, ISvcLocator *)>
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from HepRndm::BaseEngine
void | initEngine ()
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | setUpMessaging () const
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Detailed Description

### template<class TYPE>
class HepRndm::Engine< TYPE >

Definition at line 25 of file HepRndmEngine.h.

## Member Function Documentation

## ◆ BaseEngine()

template<class TYPE >

HepRndm::BaseEngine::BaseEngine
| inline

Standard Constructor.

Definition at line 34 of file HepRndmBaseEngine.h.

34 : RndmEngine( name, loc ) {}
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:274
RndmEngine
Random Generator engine definition.
Definition: RndmEngine.h:42

## ◆ createEngine() [1/12]

template<class TYPE >

std::unique_ptr<CLHEP::HepRandomEngine> HepRndm::Engine< TYPE >::createEngine | ( |  | ) |
| override private virtual

Create new HepEngine....

Implements HepRndm::BaseEngine.

## ◆ createEngine() [2/12]

template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< DualRand >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 134 of file HepRndmEngines.cpp.

134 {
135 return m_useTable ? std::make_unique<DualRand>( m_row, m_col ) : std::make_unique<DualRand>( m_seeds[0] );
136 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:32
std
STL namespace.
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:30
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:29
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27

## ◆ createEngine() [3/12]

template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< TripleRand >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 139 of file HepRndmEngines.cpp.

139 {
140 return m_useTable ? std::make_unique<TripleRand>( m_row, m_col ) : std::make_unique<TripleRand>( m_seeds[0] );
141 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:32
std
STL namespace.
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:30
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:29
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27

## ◆ createEngine() [4/12]

template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< DRand48Engine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 144 of file HepRndmEngines.cpp.

144 {
145 return m_useTable ? std::make_unique<DRand48Engine>( m_row, m_col ) : std::make_unique<DRand48Engine>( m_seeds[0] );
146 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:32
std
STL namespace.
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:30
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:29
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27

## ◆ createEngine() [5/12]

template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< Hurd160Engine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 149 of file HepRndmEngines.cpp.

149 {
150 return m_useTable ? std::make_unique<Hurd160Engine>( m_row, m_col ) : std::make_unique<Hurd160Engine>( m_seeds[0] );
151 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:32
std
STL namespace.
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:30
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:29
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27

## ◆ createEngine() [6/12]

template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< Hurd288Engine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 154 of file HepRndmEngines.cpp.

154 {
155 return m_useTable ? std::make_unique<Hurd288Engine>( m_row, m_col ) : std::make_unique<Hurd288Engine>( m_seeds[0] );
156 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:32
std
STL namespace.
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:30
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:29
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27

## ◆ createEngine() [7/12]

template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< RanecuEngine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 159 of file HepRndmEngines.cpp.

159 {
160 return m_useTable ? std::make_unique<RanecuEngine>( m_row ) : std::make_unique<RanecuEngine>( m_seeds[0] );
161 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:32
std
STL namespace.
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:30
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27

## ◆ createEngine() [8/12]

template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< RanshiEngine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 164 of file HepRndmEngines.cpp.

164 {
165 return m_useTable ? std::make_unique<RanshiEngine>( m_row, m_col ) : std::make_unique<RanshiEngine>( m_seeds[0] );
166 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:32
std
STL namespace.
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:30
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:29
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27

## ◆ createEngine() [9/12]

template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< RanluxEngine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 169 of file HepRndmEngines.cpp.

169 {
170 return m_useTable ? std::make_unique<RanluxEngine>( m_row, m_col, m_lux )
171 : std::make_unique<RanluxEngine>( m_seeds[0], m_lux );
172 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:32
std
STL namespace.
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:30
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:29
HepRndm::Engine::m_lux
Gaudi::Property< int > m_lux
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27

## ◆ createEngine() [10/12]

template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< Ranlux64Engine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 175 of file HepRndmEngines.cpp.

175 {
176 return m_useTable ? std::make_unique<Ranlux64Engine>( m_row, m_col, m_lux )
177 : std::make_unique<Ranlux64Engine>( m_seeds[0], m_lux );
178 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:32
std
STL namespace.
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:30
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:29
HepRndm::Engine::m_lux
Gaudi::Property< int > m_lux
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27

## ◆ createEngine() [11/12]

template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< MTwistEngine >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 181 of file HepRndmEngines.cpp.

181 {
182 return m_useTable ? std::make_unique<MTwistEngine>( m_row, m_col ) : std::make_unique<MTwistEngine>( m_seeds[0] );
183 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:32
std
STL namespace.
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:30
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:29
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27

## ◆ createEngine() [12/12]

template<>

std::unique_ptr< CLHEP::HepRandomEngine > HepRndm::Engine< HepJamesRandom >::createEngine | ( |  | ) |
| private virtual

Implements HepRndm::BaseEngine.

Definition at line 186 of file HepRndmEngines.cpp.

186 {
187 return m_useTable ? std::make_unique<HepJamesRandom>( m_row, m_col )
188 : std::make_unique<HepJamesRandom>( m_seeds[0] );
189 }
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:32
std
STL namespace.
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:30
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:29
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27

## ◆ finalize()

template<class TYPE >

StatusCode HepRndm::Engine< TYPE >::finalize | ( |  | ) |
| override

Finalize the Engine.

Definition at line 96 of file HepRndmEngines.cpp.

96 {
97 m_seeds.value().clear();
98 return BaseEngine::finalize();
99 }
HepRndm::BaseEngine::finalize
StatusCode finalize() override
Definition: HepRndmBaseEngine.h:40
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27

## ◆ initialize()

template<class TYPE >

StatusCode HepRndm::Engine< TYPE >::initialize | ( |  | ) |
| override

Initialize the Engine.

Definition at line 57 of file HepRndmEngines.cpp.

57 {
58 auto& seeds = m_seeds.value();
59 seeds.clear();
60 StatusCode status = RndmEngine::initialize();
61 if ( m_seeds.size() == 0 ) {
62 // Default seeds
63 long theSeed = 1234567;
64 seeds.push_back( theSeed );
65 seeds.push_back( 0 );
66 }
67 if ( status.isSuccess() ) {
68 initEngine();
69 info() << "Generator engine type:" << System::typeinfoName( typeid( *hepEngine() ) ) << endmsg;
70 if ( m_useTable ) {
71 if ( m_row > 214 || m_col > 1 ) {
72 error() << "Generator engine seed table has dimension [215][2], you gave:"
73 << " Row=" << m_row << " Column:" << m_col << endmsg;
74 status = StatusCode::FAILURE;
75 } else {
76 info() << "Generator engine seeds from table."
77 << " Row=" << m_row << " Column:" << m_col << endmsg;
78 }
79 }
80 info() << "Current Seed:" << hepEngine()->getSeed();
81 info() << " Luxury:" << m_lux.value();
82 info() << endmsg;
83 // Use the default static engine if required (e.g. for GEANT4)
84 if ( m_setSingleton ) {
85 HepRandom::setTheEngine( hepEngine() );
86 info() << "This is the GEANT4 engine!" << endmsg;
87 }
88 return status;
89 }
90 error() << "Cannot initialze random engine of type:" << System::typeinfoName( typeid( TYPE ) ) << endmsg;
91 return status;
92 }
HepRndm::BaseEngine::initEngine
void initEngine()
Definition: HepRndmBaseEngine.h:47
HepRndm::Engine::m_useTable
Gaudi::Property< bool > m_useTable
Definition: HepRndmEngine.h:32
HepRndm::Engine::seeds
StatusCode seeds(std::vector< long > &seed) const override
Retrieve seeds.
Definition: HepRndmEngines.cpp:117
System::typeinfoName
GAUDI_API const std::string typeinfoName(const std::type_info &)
Get platform independent information about the class type.
Definition: System.cpp:298
HepRndm::Engine::m_row
Gaudi::Property< int > m_row
Definition: HepRndmEngine.h:30
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:104
HepRndm::Engine::m_col
Gaudi::Property< int > m_col
Definition: HepRndmEngine.h:29
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:98
HepRndm::Engine::m_lux
Gaudi::Property< int > m_lux
Definition: HepRndmEngine.h:31
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
HepRndm::Engine::m_setSingleton
Gaudi::Property< bool > m_setSingleton
Definition: HepRndmEngine.h:33
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27
RndmEngine::initialize
StatusCode initialize() override
Service override: initialization.
Definition: RndmEngine.cpp:31
StatusCode::isSuccess
bool isSuccess() const
Definition: StatusCode.h:267
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
HepRndm::BaseEngine::hepEngine
CLHEP::HepRandomEngine * hepEngine()
Definition: HepRndmBaseEngine.h:35

## ◆ seeds()

template<class TYPE >

StatusCode HepRndm::Engine< TYPE >::seeds | ( | std::vector< long > & | seed | ) | const
| override

Retrieve seeds.

Definition at line 117 of file HepRndmEngines.cpp.

117 {
118 /*
119 const long *s = hepEngine()->getSeeds();
120 for ( size_t i = 0; i < NUMBER_OF_SEEDS; i++ ) {
121 seed.push_back(s[i]);
122 if ( m_seeds.size() > i )
123 m_seeds[i] = s[i];
124 else
125 m_seeds.push_back(s[i]);
126 }
127 */
128 seed.push_back( hepEngine()->getSeed() );
129 return StatusCode::SUCCESS;
130 }
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
std::vector::push_back
T push_back(T... args)
HepRndm::BaseEngine::hepEngine
CLHEP::HepRandomEngine * hepEngine()
Definition: HepRndmBaseEngine.h:35

## ◆ setSeeds()

template<class TYPE >

StatusCode HepRndm::Engine< TYPE >::setSeeds | ( | const std::vector< long > & | seed | ) |
| override

Set seeds.

Definition at line 103 of file HepRndmEngines.cpp.

103 {
104 auto& seeds = m_seeds.value();
105 seeds.clear();
106 std::copy( seed.begin(), seed.end(), std::back_inserter( seeds ) );
107 if ( !seeds.empty() ) {
108 if ( seeds.back() != 0 ) { seeds.push_back( 0 ); }
109 hepEngine()->setSeeds( &seeds[0], m_lux );
110 return StatusCode::SUCCESS;
111 }
112 return StatusCode::FAILURE;
113 }
std::copy
T copy(T... args)
HepRndm::Engine::seeds
StatusCode seeds(std::vector< long > &seed) const override
Retrieve seeds.
Definition: HepRndmEngines.cpp:117
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
std::vector::end
T end(T... args)
HepRndm::Engine::m_lux
Gaudi::Property< int > m_lux
Definition: HepRndmEngine.h:31
HepRndm::Engine::m_seeds
Gaudi::Property< std::vector< long > > m_seeds
Definition: HepRndmEngine.h:27
std::vector::begin
T begin(T... args)
std::back_inserter
T back_inserter(T... args)
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
HepRndm::BaseEngine::hepEngine
CLHEP::HepRandomEngine * hepEngine()
Definition: HepRndmBaseEngine.h:35

## Member Data Documentation

## ◆ m_col

template<class TYPE >

Gaudi::Property<int> HepRndm::Engine< TYPE >::m_col {this, "Column", 0}
| protected

Definition at line 29 of file HepRndmEngine.h.

## ◆ m_lux

template<class TYPE >

Gaudi::Property<int> HepRndm::Engine< TYPE >::m_lux {this, "Luxury", 3}
| protected

Definition at line 31 of file HepRndmEngine.h.

## ◆ m_row

template<class TYPE >

Gaudi::Property<int> HepRndm::Engine< TYPE >::m_row {this, "Row", 1}
| protected

Definition at line 30 of file HepRndmEngine.h.

## ◆ m_seeds

template<class TYPE >

Gaudi::Property<std::vector<long> > HepRndm::Engine< TYPE >::m_seeds {this, "Seeds", {}, "seed table"}
| mutable protected

Definition at line 27 of file HepRndmEngine.h.

## ◆ m_setSingleton

template<class TYPE >

Gaudi::Property<bool> HepRndm::Engine< TYPE >::m_setSingleton {this, "SetSingleton", false}
| protected

Definition at line 33 of file HepRndmEngine.h.

## ◆ m_useTable

template<class TYPE >

Gaudi::Property<bool> HepRndm::Engine< TYPE >::m_useTable {this, "UseTable", false}
| protected

Definition at line 32 of file HepRndmEngine.h.

The documentation for this class was generated from the following files:

- GaudiSvc/src/RndmGenSvc/HepRndmEngine.h
- GaudiSvc/src/RndmGenSvc/HepRndmEngines.cpp